unit ReadDpr;

{*********************************************************************}
{ Description:  Project Manager                                       }
{  Programmer:  Kevin S Gallagher     gallaghe@teleport.com           }
{    Comments:                                                        }
{  03/27/1999   1. Moving to D4 caused syntax highlighting to fail.   }
{                  Borland changed how IDE colors are stored.         }
{               2. I added Martin Waldenburg ClassBrowser class for   }
{                  looking at units class info. Have not check to see }
{                  if it gets everything. I tweaked code in the unit  }
{                  BrowserUnit by moving code from a TButton to read  }
{                  information from a unit into a new constructor I   }
{                  created for BrowserUnit.                           }
{ 03/12/2000    1. Fixed syntax highlighting but only works now in D4 }
{                  and above.                                         }
{*********************************************************************}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, mwPasToRtf, ComCtrls;

type
  TPasConversionClass = class of TPasConversion;

  TfrmMakeRead = class(TForm)
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    mnuFile: TMenuItem;
    StatusBar1: TStatusBar;
    Help1: TMenuItem;
    mnuViewDFM: TMenuItem;
    mnuExit: TMenuItem;
    mnuViewfileproperties: TMenuItem;
    mnuViewClassinformation: TMenuItem;
    mnuViewsource: TMenuItem;
    procedure ListBox1DblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure ListBox1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuExitClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuViewDFMClick(Sender: TObject);
    procedure mnuFileClick(Sender: TObject);
    procedure mnuViewfilepropertiesClick(Sender: TObject);
    procedure mnuViewClassinformationClick(Sender: TObject);
  private
    { Private declarations }
    procedure CheckIfProjectFile ;
    function CurrentName:String;
  public
  end;

var
  frmMakeRead: TfrmMakeRead;
  csPathTo:String;
  csPassThru:String;

procedure DprToRead(const S: String);

implementation

uses Global,
     ViewPas,
     ItemProp, BrowserUnit ;

{$R *.DFM}

function TfrmMakeRead.CurrentName:String;
begin
  Result := ExtractFilePath(csPassThru) + ListBox1.Items[ListBox1.ItemIndex] ;
  mnuViewClassinformation.Enabled := (UpperCase(ExtractFileExt(Result)) = '.PAS') ;
end;

procedure TfrmMakeRead.ListBox1DblClick(Sender: TObject);
var
  f:TfrmShowPas;
  PasCon: TPasConversion;
  P:TPoint ;
begin
  if ListBox1.Items.Count = 0 then
    exit;

  with ListBox1 do
    p := ClientToScreen(Point(Left,Top)) ;

  { Works with D4 and above }
  f := TfrmShowPas.Create(Self) ;
  PasCon := TPasConversion.Create;
  try
    Screen.Cursor := crHourGlass;
    PasCon.UseDelphiHighlighting ; // (3);
    PasCon.LoadFromFile(CurrentName);
    PasCon.ConvertReadStream;
    f.RichEdit1.Lines.BeginUpdate;
    f.RichEdit1.Lines.LoadFromStream(PasCon);
    f.RichEdit1.Lines.EndUpdate;
    f.Top := p.y ;
    f.Left := p.x ;

    lockWindowUpdate(handle) ;

    f.ShowModal ;
  finally
    PasCon.Free;
    f.Release;
    Screen.Cursor := crDefault;
    lockWindowUpdate(0) ;
  end;

end;

procedure DprToRead(const S: String);
begin
  csPassThru := S;
end;

procedure TfrmMakeRead.FormActivate(Sender: TObject);
var
  F:TextFile;
  S:String;
  cPasFile:String;
  cDprFile:String;
  iStart,iEnd:Integer;
begin

  cDprFile := csPassThru;
  csPathTo := ExtractFilePath(cDprFile);

  if not FileExists(cDprFile) then
  begin
    ErrMsg('Missing project file');
    exit;
  end;

  try
    AssignFile(F,cDprFile);
    Reset(F);
    ListBox1.Clear;
    repeat
      ReadLn(F,S);
      iStart := pos(#39,S);
      iEnd := Pos('.PAS',UpperCase(S));
      if (iStart > 0) and(iEnd > 0) then
      begin
        cPasFile := Copy(S,iStart +1,iEnd -iStart) + 'pas';
        if Copy(cPasFile,1,1) = '\' then
        begin
          if FileExists(cPasFile) then
            ListBox1.Items.Add(cPasFile);
        end else
        begin
          if FileExists(csPathTo + '\' +cPasFile) then
            ListBox1.Items.Add(cPasFile);
        end;
      end;
    until (eof(F));
  finally
    CloseFile(F);
  end;

  if ListBox1.Items.Count > 0 then
    ListBox1.ItemIndex := 0;

end;

procedure TfrmMakeRead.Help1Click(Sender: TObject);
begin
//  WinHelp(Application.Handle, 'Manager>Pop1',HELP_CONTEXTPOPUP, 400);
end;

procedure TfrmMakeRead.ListBox1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_Return then
    ListBox1DblClick(Self);
end;

procedure TfrmMakeRead.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMakeRead.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmMakeRead.mnuViewDFMClick(Sender: TObject);
  procedure LoadDFM( filename : String; Dest : TStrings );
  var
    InStream  : TFileStream;
    OutStream : TMemoryStream;
  begin
    InStream  := TFileStream.Create( filename, fmOpenReadWrite );
    OutStream := TMemoryStream.Create;
    ObjectResourceToText( InStream, OutStream );
    InStream.Free;
    OutStream.Seek(0,0);
    Dest.LoadFromStream( OutStream );
    OutStream.Free;
  end;
var
  f:TfrmShowPas;
  P:TPoint ;
begin
  if ListBox1.Items.Count = 0 then
    exit;

  with ListBox1 do
    p := ClientToScreen(Point(Left,Top)) ;

  f := TfrmShowPas.Create(Self);
  try
    f.Top := p.y ;
    f.Left := p.x ;
    LoadDFM(ChangeFileExt(CurrentName,'.DFM'), f.RichEdit1.Lines) ;
    f.ShowModal;
  finally
    f.Release ;
  end;
end;

procedure TfrmMakeRead.mnuFileClick(Sender: TObject);
var
  S:String;
  i: Integer ;
begin
  for I := 0 to mnuFile.Count -1 do
  begin
    if mnuFile.Items[I].Tag = 0 then
     mnuFile.Items[I].Enabled := True ;
  end ;

  if ListBox1.Items.Count = 0 then
  begin
    for I := 0 to mnuFile.Count -1 do
    begin
      if mnuFile.Items[I].Tag = 0 then
       mnuFile.Items[I].Enabled := False ;
    end ;
    exit ;
  end ;
    
  CheckIfProjectFile ;

  S := ChangeFileExt(CurrentName,'.DFM');
  mnuViewDFM.Enabled := FileExists(S);

    
  mnuViewsource.Enabled := False ;
  if UpperCase(ExtractFileExt(CurrentName)) = '.PAS' then
    mnuViewsource.Enabled := FileExists(CurrentName) ;


  mnuViewfileproperties.Enabled := FileExists(CurrentName);
end;

procedure TfrmMakeRead.mnuViewfilepropertiesClick(Sender: TObject);
begin
  ItemProp.DisplayPropertiesDialog(CurrentName,Self.Handle)
end;

procedure TfrmMakeRead.mnuViewClassinformationClick(Sender: TObject);
var
  f:TfrmClassBrowser ;
begin
  f := TfrmClassBrowser.Create(CurrentName,Self) ;
  try
    f.ShowModal ;
  finally
    f.Release ;
  end ;
end;

procedure TfrmMakeRead.CheckIfProjectFile;
var
  cCurrentFile: String ;
  bEnable: Boolean ;
  i: Integer ;
begin
  if ListBox1.ItemIndex = -1 then
  begin
    for I := 0 to mnuFile.Count-1 do
      if mnuFile.Items[I].Tag = 0 then
       mnuFile.Items[I].Enabled := False ;
    exit ;
  end ;

  cCurrentFile := UpperCase(ListBox1.Items.Strings[ListBox1.ItemIndex]) ;

  bEnable := not(Pos('.DPR',ExtractFileExt(cCurrentFile)) >0) ;
  for I := 0 to mnuFile.Count-1 do
  begin
    if mnuFile.Items[I].Tag = 0 then
     mnuFile.Items[I].Enabled := bEnable ;
    exit ;
  end ;

  if Pos('.DFM',ChangeFileExt(cCurrentFile,'.DFM')) >0 then
  begin
    if FileExists(ChangeFileExt(cCurrentFile,'.DFM')) then
      mnuViewDFM.enabled := True
    else
      mnuViewDFM.enabled := False ;
  end else
    mnuViewDFM.enabled := False ;
end;


end.
